<?php
/**
 * tools to decode hidden and possible malicious scripts
 */

define ('LF', "\n");
function show($vn) { echo "$vn = ".$GLOBALS[$vn].LF; }

function analyze($v, $d) {
  // recursive decoder
  $l = strlen($v);
  echo "depth $d, len $l:".LF;
  
  $v = trim($v);
  if(strpos($v, 'eval') === 0) {
    // we grab and analyze what would be eval()-ed
    
    $p1 = strpos($v, '(');
    $p2 = strpos($v, ';');
    $v2 = substr($v, $p1+1, $p2-$p1-2); #die($v2.LF);
    analyze($v2, $d+1);
    
  } else if(strpos($v, '$') === 0) {
    // a previously defined var holds a function-name

    // we isoloate the var-name
    $p1 = strpos($v, '(');
    $vn = substr($v, 1, $p1-1);

    // we get the 1st function
    $fn1 = $GLOBALS[(string)$vn];
    if($fn1 != 'gzinflate') die("depth $d: $vn = $fn1".LF.$v);

    // we isoloate the 2nd function (which is in clear-text)
    $p2 = strpos($v, '(', $p1+1); 
    $fn2 = substr($v, $p1+1, $p2-$p1-1); 
    if($fn2 != 'base64_decode') die("depth $d: $vn = $fn1".LF.$v);

    // we isolate the arg and analyze it
    $p3 = strpos($v, ')', $p2); 
    $arg = substr($v, $p2+1, $p3-$p2-1);
    analyze($fn1($fn2($arg)), $d+1);
    
  } else {
    // output what is left
    
    #echo "depth $d, len $l:".LF;
    echo $v.LF;
  }
}

